"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Animation = void 0;
const custom_attributes_1 = require("@rhtml/custom-attributes");
const animate_css_1 = require("./animate.css");
let Animation = class Animation extends custom_attributes_1.Attribute {
    OnInit() {
        this.pushStylesToParent();
        this.modify();
    }
    OnDestroy() {
        this.element.classList.remove('animated', this.value);
        this.setStyles({ animationDelay: null })(this.element);
    }
    OnUpdate() {
        this.modify();
    }
    OnUpdateAttribute() {
        this.modify();
    }
    modify() {
        this.element.classList.add('animated', this.value);
        this.setStyles({ animationDelay: this.delay })(this.element);
    }
    pushStylesToParent() {
        var _a;
        const style = document.createElement('style');
        style.innerHTML = animate_css_1.Animations;
        const root = (_a = this.parent.shadowRoot) !== null && _a !== void 0 ? _a : this.parent;
        root.prepend(style);
    }
};
exports.Animation = Animation;
__decorate([
    (0, custom_attributes_1.Input)({ observe: true }),
    __metadata("design:type", String)
], Animation.prototype, "delay", void 0);
exports.Animation = Animation = __decorate([
    (0, custom_attributes_1.Modifier)({
        selector: 'animated',
        registry() {
            return new custom_attributes_1.CustomAttributeRegistry(this);
        },
    })
], Animation);
//# sourceMappingURL=animation.js.map