"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayoutAlign = void 0;
const custom_attributes_1 = require("@rhtml/custom-attributes");
let LayoutAlign = class LayoutAlign extends custom_attributes_1.MediaQueryAttribute {
    OnInit() {
        this.modify();
        super.OnInit();
    }
    OnDestroy() {
        this.clean();
        super.OnDestroy();
    }
    OnUpdate() {
        this.modify();
    }
    OnEnterMediaQuery([, attribute]) {
        var _a;
        this.prevValue = this.value;
        this.value = (_a = attribute.value) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    OnExitMediaQuery() {
        var _a;
        this.value = (_a = this.prevValue) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    clean() {
        this.setStyles({
            alignItems: null,
            placeContent: null,
            display: null,
        })(this.element);
    }
    modify() {
        const [mainAxis, crossAxis] = this.value.split(' ');
        this.setStyles({
            alignItems: crossAxis ? crossAxis : mainAxis,
            placeContent: crossAxis
                ? `${crossAxis} ${mainAxis}`
                : `${mainAxis} ${mainAxis}`,
            display: 'flex',
        })(this.element);
    }
};
exports.LayoutAlign = LayoutAlign;
exports.LayoutAlign = LayoutAlign = __decorate([
    (0, custom_attributes_1.Modifier)({
        selector: 'fxLayoutAlign',
    })
], LayoutAlign);
//# sourceMappingURL=layout-align.js.map