"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayoutGap = void 0;
const custom_attributes_1 = require("@rhtml/custom-attributes");
let LayoutGap = class LayoutGap extends custom_attributes_1.MediaQueryAttribute {
    OnInit() {
        this.modify();
        super.OnInit();
    }
    OnDestroy() {
        this.clean();
        super.OnDestroy();
    }
    OnUpdate() {
        this.modify();
    }
    OnChange() {
        this.modify();
    }
    OnEnterMediaQuery([, attribute]) {
        var _a;
        this.prevValue = this.value;
        this.value = (_a = attribute.value) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    OnExitMediaQuery() {
        var _a;
        this.value = (_a = this.prevValue) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    clean() {
        const divs = [...this.element.children];
        for (const div of divs) {
            this.setStyles({
                flex: null,
                margin: null,
            })(div);
        }
    }
    modify() {
        const layout = this.element.getAttribute('fxlayout');
        const isRow = layout === 'row';
        const isColumn = layout === 'column';
        let margin = [this.value];
        if (isRow) {
            margin = [0, this.value, 0, 0];
        }
        if (isColumn) {
            margin = [0, 0, this.value, 0];
        }
        const divs = this.element.children;
        for (const div of divs) {
            this.setStyles({
                flex: '1 1 25%',
                margin: margin.join(' '),
            })(div);
        }
        const lastElement = this.element.children[this.element.children.length - 1];
        if (lastElement && isRow) {
            this.setStyles({
                margin: null,
            })(lastElement);
        }
    }
};
exports.LayoutGap = LayoutGap;
exports.LayoutGap = LayoutGap = __decorate([
    (0, custom_attributes_1.Modifier)({
        selector: 'fxLayoutGap',
        observe: {
            childList: true,
            subtree: true,
            attributes: true,
            attributeFilter: (0, custom_attributes_1.createFiltersFromSelector)('fxlayout'),
        },
    })
], LayoutGap);
//# sourceMappingURL=layout-gap.js.map