"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Layout = void 0;
const custom_attributes_1 = require("@rhtml/custom-attributes");
let Layout = class Layout extends custom_attributes_1.MediaQueryAttribute {
    constructor() {
        super(...arguments);
        this.value = 'row';
    }
    OnInit() {
        this.modify();
        super.OnInit();
    }
    OnDestroy() {
        this.clean();
        super.OnDestroy();
    }
    OnUpdate() {
        this.modify();
    }
    OnEnterMediaQuery([, attribute]) {
        var _a;
        this.prevValue = this.value;
        this.value = (_a = attribute.value) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    OnExitMediaQuery() {
        var _a;
        this.value = (_a = this.prevValue) !== null && _a !== void 0 ? _a : this.value;
        this.modify();
    }
    clean() {
        this.setStyles({
            boxSizing: null,
            flexFlow: null,
            display: null,
        })(this.element);
    }
    modify() {
        if (!this.value) {
            return;
        }
        this.element.setAttribute(this.selector, this.value);
        const splitted = this.value.split(' ');
        const [mainAxis, crossAxis] = splitted;
        this.setStyles({
            boxSizing: 'flex',
            flexFlow: splitted.length > 1 ? `${mainAxis} ${crossAxis}` : mainAxis,
            display: 'flex',
        })(this.element);
    }
};
exports.Layout = Layout;
exports.Layout = Layout = __decorate([
    (0, custom_attributes_1.Modifier)({
        selector: 'fxLayout',
    })
], Layout);
//# sourceMappingURL=layout.js.map